﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WindowsFormsApp1
{
    class Replay
    {
        List<string> inputs = new List<string>();
        int rider = 0;
        public bool End { get; private set; } = false;

        public Replay()
        {

        }

        //Metoda pro resetování záznamu
        public void Reset()
        {
            rider = 0;
            End = false;
        }

        //Metoda pro vymazání záznamu
        public void Clear()
        {
            inputs.Clear();
            End = false;
        }

        //Metoda pro zapsání vstupů
        public void Record(string binary, int angle)
        {
            inputs.Add(binary + "," + angle);
        }

        //Metoda pro přehrání vstupů
        public string Playback()
        {
            if (rider >= inputs.Count)
            {
                End = true;
                return "0000,0";
            }
            return inputs[rider++];
        }

        //Uložení záznamu
        public void Save(string fileName, string mapName)
        {
            FileStream fs = new FileStream(fileName, FileMode.Create);
            StreamWriter sw = new StreamWriter(fs);
            sw.WriteLine(mapName);
            foreach (string s in inputs)
            {
                sw.WriteLine(s);
            }
            sw.Close();
            fs.Close();
        }

        //Načtení záznamu
        public string Load(string filename)
        {
            Reset();
            Clear();
            FileStream fs = new FileStream(filename, FileMode.Open);
            StreamReader sr = new StreamReader(fs);
            string mapName = sr.ReadLine();
            while (!sr.EndOfStream)
            {
                inputs.Add(sr.ReadLine());
            }
            sr.Close();
            fs.Close();
            return mapName;
        }
    }
}
